def rand_list(theList):
	randomList = []
	while theList:
		try:
			popIndex = whrandom.randint(0, len(theList))
			popItem = theList.pop(popIndex)
			randomList.append(popItem)
		except IndexError:
			pass
	return randomList

def fitness(individual):
	fit_dist = 0
	for i in range(0,len(pattern)):
		for j in range(0,len(pattern[0])):
			if individual[1][i] == 1 or individual[0][j] == 1:
				fit_dist = fit_dist + max_value - pattern[i][j]
			elif individual[1][i] == 0 and individual[0][j] == 0:
				fit_dist = fit_dist + pattern[i][j]
	return fit_dist			

def mutate(individual):
	mut_idx = whrandom.randint(0, len(pattern) + len(pattern[0]) - 1)
	#print mut_idx
	if mut_idx >= len(pattern[0]): 
		return [individual[0], individual[1][0:(mut_idx - len(pattern[0]))] + [abs(individual[1][mut_idx - len(pattern[0])]-1)] + individual[1][(mut_idx - len(pattern[0]) + 1):]]
	else: 
		return [individual[0][0:mut_idx] + [abs(individual[0][mut_idx]-1)] + individual[0][mut_idx + 1:], individual[1]]

def mating(a, b):
	if whrandom.randint(0,100) < ratio_crossover * 100:
		if whrandom.randint(0,1) == 1:
			st1 = whrandom.randint(0,len(pattern))
			st2 = whrandom.randint(0,len(pattern))
			if abs(st1-st2) < 2:
				tmp = [a[0], a[1][0:st1] + b[1][st1:]]
				b =   [b[0], b[1][0:st1] + a[1][st1:]]
				a =   tmp
			else:
				tmp = [a[0], a[1][0:min(st1,st2)] + b[1][min(st1,st2):max(st1,st2)] + a[1][max(st1,st2):]]
				b =   [b[0], b[1][0:min(st1,st2)] + a[1][min(st1,st2):max(st1,st2)] + b[1][max(st1,st2):]]
				a = tmp
			if whrandom.randint(0,100) < ratio_doubleCrossover * 100:
				st1 = whrandom.randint(0,len(pattern[0]))
				st2 = whrandom.randint(0,len(pattern[0]))
				if abs(st1-st2) < 2:
					tmp = [a[0][0:st1] + b[0][st1:], a[1]]
					b =   [b[0][0:st1] + a[0][st1:], b[1]]
					a = tmp
				else:
					tmp = [a[0][0:min(st1,st2)] + b[0][min(st1,st2):max(st1,st2)] + a[0][max(st1,st2):], a[1]]
					b =   [b[0][0:min(st1,st2)] + a[0][min(st1,st2):max(st1,st2)] + b[0][max(st1,st2):], b[1]]
					a = tmp
		else:
			st1 = whrandom.randint(0,len(pattern[0]))
			st2 = whrandom.randint(0,len(pattern[0]))
			if abs(st1-st2) < 2:
				tmp = [a[0][0:st1] + b[0][st1:], a[1]]
				b =   [b[0][0:st1] + a[0][st1:], b[1]]
				a = tmp
			else:
				tmp = [a[0][0:min(st1,st2)] + b[0][min(st1,st2):max(st1,st2)] + a[0][max(st1,st2):], a[1]]
				b =   [b[0][0:min(st1,st2)] + a[0][min(st1,st2):max(st1,st2)] + b[0][max(st1,st2):], b[1]]
				a = tmp
			if whrandom.randint(0,100) < ratio_doubleCrossover * 100:
				st1 = whrandom.randint(0,len(pattern))
				st2 = whrandom.randint(0,len(pattern))
				if abs(st1-st2) < 2:
					tmp = [a[0], a[1][0:st1] + b[1][st1:]]
					b =   [b[0], b[1][0:st1] + a[1][st1:]]
					a = tmp
				else:
					tmp = [a[0], a[1][0:min(st1,st2)] + b[1][min(st1,st2):max(st1,st2)] + a[1][max(st1,st2):]]
					b =   [b[0], b[1][0:min(st1,st2)] + a[1][min(st1,st2):max(st1,st2)] + b[1][max(st1,st2):]]
					a = tmp
		return [a,b]
	else:
		return [[a[0],b[1]], [b[0],a[1]]]

def ga2wySearch(pa):
	# ---------------------------------------------------------------------
	# initialize chromosomes
	popul = []
	for i in range(0, no_generation):
		xChr = yChr = []
		for j in range(0,len(pa[0])): xChr = xChr + [whrandom.randint(0,1)]
		for j in range(0,len(pa)): yChr = yChr + [whrandom.randint(0,1)]
		popul  = popul + [[xChr, yChr]]

	newPopul = popul

	for gen in range(0, max_round):
		# evaluate and select the fittest
		fittest_list = []
		for i in range(0, len(newPopul)):
			fittest_list.append([fitness(newPopul[i]), i])
		fittest_list.sort()

		fitPopul = []
		for i in range(0, no_fitness):	
			fitPopul.append(newPopul[fittest_list[i][1]])

		# exit condition
		print 'Round ', gen, ':', fittest_list[0] , ':', newPopul[fittest_list[0][1]], '\n'
		if fittest_list[0][0] <= stop_score or gen == max_round-1:
			break

		# select mates and crossover		co * 2
		newPopul = fitPopul
		for i in range(0, (no_generation - len(newPopul))/2):
			x = newPopul[whrandom.randint(0,len(newPopul)-1)]
			y = newPopul[whrandom.randint(0,len(newPopul)-1)]
			children = mating(x,y)
			newPopul = newPopul + [children[0]] + [children[1]]

		#mutate
		for i in range(0, len(newPopul)):
			if whrandom.randint(0,100) < ratio_mutate * 100:
				newPopul[i] = mutate(newPopul[i])
	return([gen, fittest_list[0][0], newPopul[fittest_list[0][1]]])


#------------------------------------------------
from string import *
import whrandom
import sys

no_generation = 100
no_fitness = 20
ratio_crossover = .5
ratio_doubleCrossover = .5
ratio_mutate = .6

max_value = 9	# should adjust max_value! (it equals zero when binary), mininum value is set to zero.
max_round = 30
stop_score = 0
no_permutation = 100
#------------------------------------------------
#------------------------------------------------


#(ex) 6 * 9 pattern
pattern = []
pattern.append([0,0,0,1,0,0,0,1,0])
pattern.append([0,1,0,1,0,0,0,1,0])
pattern.append([0,0,0,1,0,0,0,1,0])
pattern.append([0,0,0,1,0,0,0,1,0])
pattern.append([0,0,0,0,0,0,0,1,0])
pattern.append([1,1,1,1,1,1,1,1,1])
pattern.append([0,0,0,1,0,0,0,1,0])

max_value = 1
gaPack = ga2wySearch(pattern)


#pause for the next demonstration of a non-binary case
a=raw_input()

pattern = []
pattern.append([ 4, 0, 0, 9, 0, 5, 5, 3, 3])
pattern.append([ 9, 9, 9, 4, 0, 4, 3, 7, 4])
pattern.append([ 3, 3, 0, 9, 0, 5, 9, 5, 2])
pattern.append([ 4, 2, 0, 9, 0, 9, 4, 3, 3])
pattern.append([ 2, 4, 0, 9, 0, 8, 5, 6, 3])
pattern.append([ 5, 0, 0, 9, 0, 9, 2, 0, 2])
pattern.append([ 4, 0, 0, 9, 0, 9, 2, 0, 2])
pattern.append([ 9, 7, 9, 9, 0, 9, 8, 7, 2])
pattern.append([ 9, 7, 9, 9, 0, 9, 8, 7, 2])
pattern.append([ 9, 7, 9, 9, 0, 9, 8, 7, 2])

max_value = 9
gaPack = ga2wySearch(pattern)





